"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Schema = void 0;
const epic_sql_query_1 = require("epic-sql-query");
const enums_1 = require("./enums");
const Schema = (options) => (constructor) => {
    Reflect.defineMetadata(enums_1.MetaDataKeys.SCHEMA, {
        name: (options === null || options === void 0 ? void 0 : options.name) || constructor.name.toLowerCase(),
    }, constructor.prototype);
    Object.defineProperty(constructor.prototype, "getSchemaInfo", {
        value: function () {
            const SchemaDetails = Reflect.getMetadata(enums_1.MetaDataKeys.SCHEMA, this) || {};
            const SchemaData = Reflect.getMetadata(enums_1.MetaDataKeys.SCHEMA_DATA, this) || {};
            const SchemaIndexes = Reflect.getMetadata(enums_1.MetaDataKeys.SCHEMA_INDEXS, this) || {};
            return Object.assign(Object.assign({}, SchemaDetails), { primaryKey: Object.values(SchemaIndexes).reduce((key, index) => key
                    ? key
                    : index.type === enums_1.MetaDataKeys.PRIMARY_KEY_INDEX
                        ? index
                        : null, null), data: SchemaData, indexes: SchemaIndexes });
        },
    });
    Object.defineProperty(constructor.prototype, "getSchemaName", {
        value: function () {
            const SchemaDetails = Reflect.getMetadata(enums_1.MetaDataKeys.SCHEMA, this) || {};
            return SchemaDetails.name;
        },
    });
    Object.defineProperty(constructor.prototype, "createTable", {
        value: function (Schema) {
            const NativeSchema = this.getSchemaInfo();
            return new epic_sql_query_1.Table((Schema === null || Schema === void 0 ? void 0 : Schema.name) || NativeSchema.name, Object.values((Schema === null || Schema === void 0 ? void 0 : Schema.data) || NativeSchema.data).reduce((schema, options) => (Object.assign(Object.assign({}, schema), { [options.name]: new epic_sql_query_1.Column({
                    isPrimaryKey: options.primaryKey,
                    isLength: options.length,
                    isIndex: options.index,
                    isNullable: options.nullable,
                    isCollation: options.collation,
                }) })), {}));
        },
    });
    Object.defineProperty(constructor.prototype, "isFilled", {
        value: function () {
            const NativeSchema = this.getSchemaInfo();
            // Check If Schema is Filled
            return [
                ...Object.keys(NativeSchema.data),
                ...Object.keys(NativeSchema.indexes),
            ].reduce((state, column) => (state ? state : !!this[column]), false);
        },
    });
};
exports.Schema = Schema;
